﻿using UnityEditor;
using UnityEngine;

public class CustomMenuOptions : MonoBehaviour
{

    [MenuItem("CONTEXT/Transform/Pos + Scale over 10")]
    static void ScaleBothDown(MenuCommand menuCommand)
    {
        //Prevent executing multiple times when right-clicking.
        if (Selection.gameObjects.Length > 1 && menuCommand.context != Selection.gameObjects[0].transform)
        {
            return;
        }
        foreach (GameObject go in Selection.gameObjects)
        {
            Undo.RecordObject(go.transform, "scaled");
            go.transform.localScale /= 10;
            go.transform.position /= 10;
            EditorUtility.SetDirty(go.transform);
        }
    }

    [MenuItem("CONTEXT/Transform/Pos over 10")]
    static void ScalePosDown(MenuCommand menuCommand)
    {
				//Prevent executing multiple times when right-clicking.
        if (Selection.gameObjects.Length > 1 && menuCommand.context != Selection.gameObjects[0].transform)
        {
            return;
        }
        foreach (GameObject go in Selection.gameObjects)
        {
            Undo.RecordObject(go.transform, "scaled");
            go.transform.position /= 10;
            EditorUtility.SetDirty(go.transform);
        }
    }
}