using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;


[CustomEditor(typeof(RadialJedi))]
public class RadialJediEditor : Editor {

    void OnEnable() {

    }

    void OnSceneGUI() {
        RadialJedi t = target as RadialJedi;

        // Show the force arrows
        if (t.accelPercentage <= 0) {
            for ( int i = 0; i < 6; i++ ) {
                Handles.ArrowCap(0,
                    t.transform.position,
                    Quaternion.Euler(new Vector3(60 * i + 30, 90, 0)),
                    -t.accelPercentage * t.radius);
            }
        } else {
            for ( int i = 0; i < 6; i++ ) {
                Handles.ArrowCap(0,
                    t.transform.position + (Quaternion.Euler(new Vector3(60 * i, 90, 0)) * Vector3.up * 3),
                    Quaternion.Euler(new Vector3((60 * i)-90, 90, 0)),
                    -t.accelPercentage * t.radius);
            }
        }


        // Show the radius handle
        EditorGUI.BeginChangeCheck();
        float areaOfEffect = Handles.RadiusHandle(Quaternion.identity, t.transform.position, t.radius);
        if ( EditorGUI.EndChangeCheck() ) {
            Undo.RecordObject(target, "Changed Area Of Effect");
            t.radius = areaOfEffect;
        }

    }

}
