﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

[CustomEditor(typeof(WaypointSystem))]
public class WaypointSystemEditor : Editor
{
	private void OnSceneGUI()
	{
		WaypointSystem t = target as WaypointSystem;

		Handles.color = t.handleColor;

		if(!Application.isPlaying)
			t.waypointPositions[0] = t.transform.position;

		for(int i=0; i<t.waypointPositions.Length; i++)
		{
			if(t.bShowPositionHandles && i != 0)
				t.waypointPositions[i] = Handles.PositionHandle(t.waypointPositions[i],Quaternion.identity);

			Handles.CubeCap(0,t.waypointPositions[i],Quaternion.identity,t.waypointSize);

			if(i < t.waypointPositions.Length - 1)
			{
				Vector3 viewVector = t.waypointPositions[i + 1] - t.waypointPositions[i];

				if(viewVector != Vector3.zero)
					Handles.ArrowCap(0,Vector3.Lerp(t.waypointPositions[i + 1],t.waypointPositions[i],0.8f),Quaternion.LookRotation(viewVector,Vector3.back),t.arrowSize);
			}
		}
	}
}
