using System.Collections;
using System.Collections.Generic;
using UnityEngine;

/// <summary>
/// It's a Jedi because it's using (the) force.
/// </summary>
[ExecuteInEditMode]
public abstract class Jedi : MonoBehaviour
{	
	public float accelPercentage = 0.85f;
	public bool bPulsing;
	public float pulseSpeed = 1.5f;
	public Transform pulseImage;

	private void Start()
	{
		
	}

	public void ApplyForceToDrone(Drone drone,Vector2 force)
	{
		if(drone != null)
		{
			float finalAcceleration = accelPercentage;

			if(bPulsing)
			{
				finalAcceleration *= (Mathf.Sin(Time.time * pulseSpeed)/2f) + 0.8f;
			}

			finalAcceleration *= drone.attractionAccel;

			force = force.normalized * finalAcceleration;

			drone.rb.AddForce(force);
		}
	}
}
