using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FollowerArea : MonoBehaviour {

	private PlayerNumber playerNum;
	public HashSet<Drone> dronesInRange = new HashSet<Drone>();
	private Drone[] dronesInRangeAsArray = new Drone[400];

	public AudioSource audioSource { get; set; }
	public AudioClip neutralConvSound;
	public List<AudioClip> footstepSounds = new List<AudioClip>();

	public SpriteRenderer sprite;

	private Vector3 pos;

	// Use this for initialization
	void Start () {
		HumanInput player = transform.parent.GetComponent<HumanInput>();

		playerNum = player.playerNumber;

		sprite.color = new Color(player.playerColor.r,player.playerColor.g,player.playerColor.b,sprite.color.a);

		audioSource = GetComponent<AudioSource>();
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	public HashSet<Drone> DronesInRange() {
		return dronesInRange;
	}

	void OnTriggerStay2D(Collider2D collider) {
		Drone drone = collider.GetComponent<Drone>();

		if (drone != null)
		{
			//bool bInvokingPlayerZero = drone.IsInvoking("ConvertToPlayerZero");

			if(drone.playerNum == PlayerNumber.None/* || bInvokingPlayerZero*/) {
				drone.Convert(playerNum);
				dronesInRange.Add(drone);

				if(!audioSource.isPlaying)
					audioSource.PlayOneShot(neutralConvSound);
			}
			
			if (drone.playerNum == playerNum) {
				drone.CancelPlayerZeroConvert();
			}

			if(!audioSource.isPlaying && !IsInvoking("FootStepSound") && pos != transform.position)
			{
				Invoke("FootStepSound",0.1f);	
			}

			pos = transform.position;
		}
	}

	private void FootStepSound()
	{
		audioSource.PlayOneShot(footstepSounds[Random.Range(0,footstepSounds.Count)]);
	}

	void OnTriggerExit2D(Collider2D collider) {
		Drone drone = collider.GetComponent<Drone>();
		if (drone != null && drone.playerNum == playerNum) {
			drone.TimerToPlayerZeroStart();
			dronesInRange.Remove(drone);
		}


	}
}
