using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HumanInput : MonoBehaviour {

	// Set in editor
	public PlayerNumber playerNumber;
	public Color playerOneColor;
	public Color playerTwoColor;

	private SwarmTarget _swarmTarget;
    public SwarmTarget swarmTarget { get { return _swarmTarget; } }

    public Color playerColor { get; private set; }

    private Camera cam;

	// Use this for initialization
	void Awake () {
		_swarmTarget = GetComponent<SwarmTarget>();
		playerColor = playerNumber == PlayerNumber.One ? playerOneColor : playerTwoColor;
		GetComponent<Renderer>().material.color = playerColor;
	}
	
	// Update is called once per frame
	void Update () {
		Vector2 input = Vector2.zero;
		if (playerNumber == PlayerNumber.One) {
			input = new Vector2(Input.GetAxisRaw("Horizontal"), Input.GetAxisRaw("Vertical"));
		} else {
			input = new Vector2(Input.GetAxisRaw("HorizontalP2"), Input.GetAxisRaw("VerticalP2"));
		}

		_swarmTarget.Move(input);
	}
}
