using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SwarmTarget : MonoBehaviour {

	public static List<SwarmTarget> allSwarmTargets = new List<SwarmTarget>();

	public bool bExplodeSoundReady { get; set; }
	public AudioSource audioSource { get; set; }

	public AudioClip beastMode,explode;
	public List<AudioClip> conversionSounds = new List<AudioClip>();

	// Set in editor
	public float speed;
    // Get reference to camera to set borders
    Camera cam;

    private Vector2 camBorderMax;
    private Vector3 lastPos;

	public HumanInput player { get; private set; }

	void Start () {
        // Get reference to camera to set borders
        cam = Camera.main;
        lastPos = transform.position;

		allSwarmTargets.Add(this);

		player = GetComponent<HumanInput>();
		audioSource = GetComponent<AudioSource>();
    }
	
	// Update is called once per frame
	void Update () {
        clampPos();
    }

	// Processes the input from the player
	public void Move(Vector2 input) {
		transform.position += (Vector3)input.normalized * speed * Time.deltaTime;
	}

    private void clampPos() {
        // get position in screen space
        Vector3 screenPos = cam.WorldToScreenPoint(transform.position);

        if ( screenPos.x >= Screen.width || screenPos.x <= 0 || screenPos.y >= Screen.height || screenPos.y <= 0 ){
            transform.position = lastPos;
        } else {
            lastPos = transform.position;
        }

        
    }

	public void ExplodeSoundReady()
	{
		bExplodeSoundReady = true;
	}
}
