﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody2D))]
public class WaypointSystem : MonoBehaviour
{
	private Rigidbody2D rb;
	
	public Vector3[] waypointPositions = new Vector3[1];
	public float speed = 5;
	public bool bLooping;
	private float distToDest;
	private int _waypointIndexStart;
	private int waypointIndexStart
	{
		get{ return _waypointIndexStart; }
		set
		{
			if(bLooping)
			{
				if(value >= waypointPositions.Length)
				{
					value = 0;
				}
			}
			else if(value >= waypointPositions.Length - 1)
			{
				value = 0;

				Reset();
			}

			_waypointIndexStart = value;
		}
	}
	private int waypointIndexDest
	{
		get
		{
			int destIndex = waypointIndexStart + 1;

			if(destIndex >= waypointPositions.Length)
				destIndex = 0;

			return destIndex;
		}
	}

	[Space(10)]
	[Header("---Scene View---")]
	public bool bShowPositionHandles = true;
	public Color handleColor = Color.magenta;
	public float waypointSize = 1f;
	public float arrowSize = 6f;

	private void Start()
	{
		rb = GetComponent<Rigidbody2D>();

		Reset();
	}

	private void FixedUpdate()
	{
		if(Vector3.Distance(transform.position,waypointPositions[waypointIndexDest]) > distToDest)
		{
			waypointIndexStart++;


		}

		rb.velocity = (waypointPositions[waypointIndexDest] - waypointPositions[waypointIndexStart]).normalized * speed;

		distToDest = Vector3.Distance(transform.position,waypointPositions[waypointIndexDest]);
	}

	public void Reset()
	{
		waypointIndexStart = 0;

		transform.position = waypointPositions[waypointIndexStart];

		distToDest = 100000;
	}
}
